#version 330 core

in vec4 eyeSpaceVertexF;
in vec2 texCoord;
flat in vec3 vNormal;

out vec4 color;

uniform sampler2D texAtlas;

uniform struct Environment
{
    vec3 sunLightColor;
    vec3 sunLightDirection;
    float ambient;
    float fogDensity;
    vec3 fogColor;
} env;

void main()
{
    float diffuse = max(0.0, dot(vNormal, -env.sunLightDirection));
    float fogFactor = 1.0 - clamp(exp(-pow(env.fogDensity * (eyeSpaceVertexF.z / eyeSpaceVertexF.w), 2.0)), 0.0, 1.0);
    color = mix(texture(texAtlas, texCoord) * vec4(env.sunLightColor * (env.ambient + diffuse), 1.0), vec4(env.fogColor, 1.0), fogFactor);
}