#version 330 core

layout(points) in;
layout(triangle_strip, max_vertices = 4) out;

out vec4 eyeSpaceVertexF;
out vec2 texCoord;
flat out vec3 vNormal;

uniform mat4 proM;
uniform mat4 viewM;
uniform int planeType;
uniform vec2 planeTextures[4];

void main() 
{
    vec4 workingV;

    if(planeType == 3)
    {
        vNormal = vec3(0.0, -1.0, 0.0);

        workingV = gl_in[0].gl_Position + vec4(-0.5, 0.0, -0.5, 0.0);
        eyeSpaceVertexF = viewM * workingV;
        gl_Position = proM * eyeSpaceVertexF;
        texCoord = planeTextures[0];
        EmitVertex();

        workingV = gl_in[0].gl_Position + vec4(0.5, 0.0, -0.5, 0.0);
        eyeSpaceVertexF = viewM * workingV;
        gl_Position = proM * eyeSpaceVertexF;
        texCoord = planeTextures[3];
        EmitVertex();

        workingV = gl_in[0].gl_Position + vec4(-0.5, 0.0, 0.5, 0.0);
        eyeSpaceVertexF = viewM * workingV;
        gl_Position = proM * eyeSpaceVertexF;
        texCoord = planeTextures[1];
        EmitVertex();

        workingV = gl_in[0].gl_Position + vec4(0.5, 0.0, 0.5, 0.0);
        eyeSpaceVertexF = viewM * workingV;
        gl_Position = proM * eyeSpaceVertexF;
        texCoord = planeTextures[2];
        EmitVertex();
        EndPrimitive();
    }
    else if(planeType == 2)
    {
        vNormal = vec3(0.0, 1.0, 0.0);

        workingV = gl_in[0].gl_Position + vec4(-0.5, 0.0, -0.5, 0.0);
        eyeSpaceVertexF = viewM * workingV;
        gl_Position = proM * eyeSpaceVertexF;
        texCoord = planeTextures[3];
        EmitVertex();

        workingV = gl_in[0].gl_Position + vec4(-0.5, 0.0, 0.5, 0.0);
        eyeSpaceVertexF = viewM * workingV;
        gl_Position = proM * eyeSpaceVertexF;
        texCoord = planeTextures[2];
        EmitVertex();

        workingV = gl_in[0].gl_Position + vec4(0.5, 0.0, -0.5, 0.0);
        eyeSpaceVertexF = viewM * workingV;
        gl_Position = proM * eyeSpaceVertexF;
        texCoord = planeTextures[0];
        EmitVertex();

        workingV = gl_in[0].gl_Position + vec4(0.5, 0.0, 0.5, 0.0);
        eyeSpaceVertexF = viewM * workingV;
        gl_Position = proM * eyeSpaceVertexF;
        texCoord = planeTextures[1];
        EmitVertex();
        EndPrimitive();
    }
    else if(planeType == 0)
    {
        vNormal = vec3(-1.0, 0.0, 0.0);

        workingV = gl_in[0].gl_Position + vec4(0.0, 0.5, -0.5, 0.0);
        eyeSpaceVertexF = viewM * workingV;
        gl_Position = proM * eyeSpaceVertexF;
        texCoord = planeTextures[0];
        EmitVertex();

        workingV = gl_in[0].gl_Position + vec4(0.0, -0.5, -0.5, 0.0);
        eyeSpaceVertexF = viewM * workingV;
        gl_Position = proM * eyeSpaceVertexF;
        texCoord = planeTextures[3];
        EmitVertex();

        workingV = gl_in[0].gl_Position + vec4(0.0, 0.5, 0.5, 0.0);
        eyeSpaceVertexF = viewM * workingV;
        gl_Position = proM * eyeSpaceVertexF;
        texCoord = planeTextures[1];
        EmitVertex();

        workingV = gl_in[0].gl_Position + vec4(0.0, -0.5, 0.5, 0.0);
        eyeSpaceVertexF = viewM * workingV;
        gl_Position = proM * eyeSpaceVertexF;
        texCoord = planeTextures[2];
        EmitVertex();
        EndPrimitive();
    }
    else if(planeType == 1)
    {
        vNormal = vec3(1.0, 0.0, 0.0);

        workingV = gl_in[0].gl_Position + vec4(0.0, -0.5, -0.5, 0.0);
        eyeSpaceVertexF = viewM * workingV;
        gl_Position = proM * eyeSpaceVertexF;
        texCoord = planeTextures[0];
        EmitVertex();

        workingV = gl_in[0].gl_Position + vec4(0.0, 0.5, -0.5, 0.0);
        eyeSpaceVertexF = viewM * workingV;
        gl_Position = proM * eyeSpaceVertexF;
        texCoord = planeTextures[3];
        EmitVertex();

        workingV = gl_in[0].gl_Position + vec4(0.0, -0.5, 0.5, 0.0);
        eyeSpaceVertexF = viewM * workingV;
        gl_Position = proM * eyeSpaceVertexF;
        texCoord = planeTextures[1];
        EmitVertex();

        workingV = gl_in[0].gl_Position + vec4(0.0, 0.5, 0.5, 0.0);
        eyeSpaceVertexF = viewM * workingV;
        gl_Position = proM * eyeSpaceVertexF;
        texCoord = planeTextures[2];
        EmitVertex();
        EndPrimitive();
    }
    else if(planeType == 5)
    {
        vNormal = vec3(0.0, 0.0, -1.0);

        workingV = gl_in[0].gl_Position + vec4(-0.5, 0.5, 0.0, 0.0);
        eyeSpaceVertexF = viewM * workingV;
        gl_Position = proM * eyeSpaceVertexF;
        texCoord = planeTextures[0];
        EmitVertex();

        workingV = gl_in[0].gl_Position + vec4(0.5, 0.5, 0.0, 0.0);
        eyeSpaceVertexF = viewM * workingV;
        gl_Position = proM * eyeSpaceVertexF;
        texCoord = planeTextures[3];
        EmitVertex();

        workingV = gl_in[0].gl_Position + vec4(-0.5, -0.5, 0.0, 0.0);
        eyeSpaceVertexF = viewM * workingV;
        gl_Position = proM * eyeSpaceVertexF;
        texCoord = planeTextures[1];
        EmitVertex();

        workingV = gl_in[0].gl_Position + vec4(0.5, -0.5, 0.0, 0.0);
        eyeSpaceVertexF = viewM * workingV;
        gl_Position = proM * eyeSpaceVertexF;
        texCoord = planeTextures[2];
        EmitVertex();
        EndPrimitive();
    }
    else if(planeType == 4)
    {
        vNormal = vec3(0.0, 0.0, 1.0);

        workingV = gl_in[0].gl_Position + vec4(-0.5, -0.5, 0.0, 0.0);
        eyeSpaceVertexF = viewM * workingV;
        gl_Position = proM * eyeSpaceVertexF;
        texCoord = planeTextures[0];
        EmitVertex();

        workingV = gl_in[0].gl_Position + vec4(0.5, -0.5, 0.0, 0.0);
        eyeSpaceVertexF = viewM * workingV;
        gl_Position = proM * eyeSpaceVertexF;
        texCoord = planeTextures[3];
        EmitVertex();

        workingV = gl_in[0].gl_Position + vec4(-0.5, 0.5, 0.0, 0.0);
        eyeSpaceVertexF = viewM * workingV;
        gl_Position = proM * eyeSpaceVertexF;
        texCoord = planeTextures[1];
        EmitVertex();

        workingV = gl_in[0].gl_Position + vec4(0.5, 0.5, 0.0, 0.0);
        eyeSpaceVertexF = viewM * workingV;
        gl_Position = proM * eyeSpaceVertexF;
        texCoord = planeTextures[2];
        EmitVertex();
        EndPrimitive();
    }
}